<?php

namespace Drupal\cms_content_sync\SyncCore\V1;

/**
 *
 */
abstract class SerializableWithSyncCoreReference implements \Serializable {

  /**
   * @var SyncCore
   */
  protected $core;

  /**
   * SerializableWithSyncCoreReference constructor.
   *
   * @param SyncCore $core
   */
  public function __construct($core) {
    $this->core = $core;
  }

  /**
   * @return string[]
   */
  protected function serializeSyncCore() {
    return [$this->core->getBaseUrl(), get_class($this->core->getApplication())];
  }

  /**
   * @param string[] $serialized
   */
  public function unserializeSyncCore($serialized) {
    $base_url = $serialized[0];
    $app = $serialized[1];

    $this->core = SyncCore::get($base_url, $app::get());
  }

}
