<?php

namespace Drupal\cms_content_sync;

/**
 *
 */
abstract class SyncCoreExport {
  /**
   * @var \Drupal\cms_content_sync\SyncCore\Interfaces\ISyncCore
   */
  protected $client;

  /**
   * @param \Drupal\cms_content_sync\SyncCore\Interfaces\ISyncCore $client
   */
  public function __construct($client) {
    $this->client = $client;
  }

  /**
   * @return \Drupal\cms_content_sync\SyncCore\Interfaces\ISyncCore
   */
  public function getClient() {
    return $this->client;
  }

  /**
   * Prepare the Sync Core push as a batch operation. Return a batch array
   * with single steps to be executed.
   *
   * @return \Drupal\cms_content_sync\SyncCore\Interfaces\IBatch
   *
   * @throws \Drupal\cms_content_sync\SyncCore\Exception\SyncCoreException
   */
  abstract public function prepareBatch();

}
